Document the --(no-)edit switch of git-revert and git-cherry-pick
[git/dscho.git] / git-merge-one-file.sh
blobeafef770dbad16b48f25962cd67e8e380f3c8d48
1 #!/bin/sh
3 # Copyright (c) Linus Torvalds, 2005
5 # This is the git per-file merge script, called with
7 # $1 - original file SHA1 (or empty)
8 # $2 - file in branch1 SHA1 (or empty)
9 # $3 - file in branch2 SHA1 (or empty)
10 # $4 - pathname in repository
11 # $5 - orignal file mode (or empty)
12 # $6 - file in branch1 mode (or empty)
13 # $7 - file in branch2 mode (or empty)
15 # Handle some trivial cases.. The _really_ trivial cases have
16 # been handled already by git-read-tree, but that one doesn't
17 # do any merges that might change the tree layout.
19 case "${1:-.}${2:-.}${3:-.}" in
21 # Deleted in both or deleted in one and unchanged in the other
23 "$1.." | "$1.$1" | "$1$1.")
24 if [ "$2" ]; then
25 echo "Removing $4"
27 if test -f "$4"; then
28 rm -f -- "$4" &&
29 rmdir -p "$(expr "$4" : '\(.*\)/')" 2>/dev/null || :
30 fi &&
31 exec git-update-index --remove -- "$4"
35 # Added in one.
37 ".$2." | "..$3" )
38 echo "Adding $4"
39 git-update-index --add --cacheinfo "$6$7" "$2$3" "$4" &&
40 exec git-checkout-index -u -f -- "$4"
44 # Added in both, identically (check for same permissions).
46 ".$3$2")
47 if [ "$6" != "$7" ]; then
48 echo "ERROR: File $4 added identically in both branches,"
49 echo "ERROR: but permissions conflict $6->$7."
50 exit 1
52 echo "Adding $4"
53 git-update-index --add --cacheinfo "$6" "$2" "$4" &&
54 exec git-checkout-index -u -f -- "$4"
58 # Modified in both, but differently.
60 "$1$2$3" | ".$2$3")
62 case ",$6,$7," in
63 *,120000,*)
64 echo "ERROR: $4: Not merging symbolic link changes."
65 exit 1
67 esac
69 src2=`git-unpack-file $3`
70 case "$1" in
71 '')
72 echo "Added $4 in both, but differently."
73 # This extracts OUR file in $orig, and uses git-apply to
74 # remove lines that are unique to ours.
75 orig=`git-unpack-file $2`
76 sz0=`wc -c <"$orig"`
77 diff -u -La/$orig -Lb/$orig $orig $src2 | git-apply --no-add
78 sz1=`wc -c <"$orig"`
80 # If we do not have enough common material, it is not
81 # worth trying two-file merge using common subsections.
82 expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
85 echo "Auto-merging $4."
86 orig=`git-unpack-file $1`
88 esac
90 # Create the working tree file, with the correct permission bits.
91 # we can not rely on the fact that our tree has the path, because
92 # we allow the merge to be done in an unchecked-out working tree.
93 rm -f "$4" &&
94 git-cat-file blob "$2" >"$4" &&
95 case "$6" in *7??) chmod +x "$4" ;; esac &&
96 merge "$4" "$orig" "$src2"
97 ret=$?
98 rm -f -- "$orig" "$src2"
100 if [ "$6" != "$7" ]; then
101 echo "ERROR: Permissions conflict: $5->$6,$7."
102 ret=1
104 if [ "$1" = '' ]; then
105 ret=1
108 if [ $ret -ne 0 ]; then
109 echo "ERROR: Merge conflict in $4."
110 exit 1
112 exec git-update-index -- "$4"
116 echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
118 esac
119 exit 1